## freerdp3 3.15.0+dfsg

=== CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
# Copyright 2012 HP Development Company, LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.13)

if(POLICY CMP0091)
  cmake_policy(SET CMP0091 NEW)
endif()
project(FreeRDP LANGUAGES C)

add_custom_target(fuzzers COMMENT "Build fuzzers")

if(NOT PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
  # Git auto-ignore out-of-source build directory
  file(GENERATE OUTPUT .gitignore CONTENT "*")
endif()

if(NOT DEFINED VENDOR)
  set(VENDOR "FreeRDP" CACHE STRING "FreeRDP package vendor")
endif()

if(NOT DEFINED PRODUCT)
  set(PRODUCT "FreeRDP" CACHE STRING "FreeRDP package name")
endif()

if(NOT DEFINED FREERDP_VENDOR)
  set(FREERDP_VENDOR 1)
endif()

if(NOT WIN32 AND NOT ANDROID)
  if(APPLE)
    set(OPT_DEFAULT_VAL OFF)
  else()
    set(OPT_DEFAULT_VAL ON)
  endif()
  option(WITH_X11 "build X11 client/server" ${OPT_DEFAULT_VAL})
endif()

# Enable coverity related pragma definitions
if(COVERITY_BUILD)
  add_compile_definitions(COVERITY_BUILD)
endif()

# Include our extra modules
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/)

include(ProjectCStandard)

# Check for cmake compatibility (enable/disable features)
include(CheckCmakeCompat)

# Include cmake modules
if(WITH_CLANG_FORMAT)
  include(ClangFormat)
endif()

include(CompilerFlags)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CheckStructHasMember)
include(TestBigEndian)
include(CompilerDetect)

include(FindFeature)
include(ShowCMakeVars)
include(ConfigOptions)
include(FeatureSummary)
include(CheckCCompilerFlag)
include(CMakePackageConfigHelpers)
include(InstallFreeRDPMan)
include(GetGitRevisionDescription)
include(SetFreeRDPCMakeInstallDir)
include(Doxygen)

# Soname versioning
set(BUILD_NUMBER 0)
if($ENV{BUILD_NUMBER})
  set(BUILD_NUMBER $ENV{BUILD_NUMBER})
endif()

set(VERSION_REGEX "^(.*)([0-9]+)\\.([0-9]+)\\.([0-9]+)-?(.*)")
set(RAW_VERSION_STRING "3.15.0")
if(EXISTS "${PROJECT_SOURCE_DIR}/.source_tag")
  file(READ ${PROJECT_SOURCE_DIR}/.source_tag RAW_VERSION_STRING)
elseif(USE_VERSION_FROM_GIT_TAG)
  git_get_exact_tag(_GIT_TAG --tags --always)
  if(NOT ${_GIT_TAG} STREQUAL "n/a")
    string(REGEX MATCH ${VERSION_REGEX} FOUND_TAG "${_GIT_TAG}")
    if(FOUND_TAG)
      set(RAW_VERSION_STRING ${_GIT_TAG})
    endif()
  endif()
endif()
string(STRIP ${RAW_VERSION_STRING} RAW_VERSION_STRING)

string(REGEX REPLACE "${VERSION_REGEX}" "\\2" FREERDP_VERSION_MAJOR "${RAW_VERSION_STRING}")
string(REGEX REPLACE "${VERSION_REGEX}" "\\3" FREERDP_VERSION_MINOR "${RAW_VERSION_STRING}")
string(REGEX REPLACE "${VERSION_REGEX}" "\\4" FREERDP_VERSION_REVISION "${RAW_VERSION_STRING}")
string(REGEX REPLACE "${VERSION_REGEX}" "\\5" FREERDP_VERSION_SUFFIX "${RAW_VERSION_STRING}")

set(FREERDP_API_VERSION "${FREERDP_VERSION_MAJOR}")
set(FREERDP_VERSION "${FREERDP_VERSION_MAJOR}.${FREERDP_VERSION_MINOR}.${FREERDP_VERSION_REVISION}")
if(FREERDP_VERSION_SUFFIX)
  set(FREERDP_VERSION_FULL "${FREERDP_VERSION}-${FREERDP_VERSION_SUFFIX}")
else()
  set(FREERDP_VERSION_FULL "${FREERDP_VERSION}")
endif()
message("FREERDP_VERSION=${FREERDP_VERSION_FULL}")

if(EXISTS "${PROJECT_SOURCE_DIR}/.source_version")
  file(READ ${PROJECT_SOURCE_DIR}/.source_version GIT_REVISION)

  string(STRIP ${GIT_REVISION} GIT_REVISION)
elseif(USE_VERSION_FROM_GIT_TAG)
  git_get_exact_tag(GIT_REVISION --tags --always)

  if(${GIT_REVISION} STREQUAL "n/a")
    git_rev_parse(GIT_REVISION --short)
  endif()
endif()

if(NOT GIT_REVISION)
  set(GIT_REVISION ${FREERDP_VERSION})
endif()

message(STATUS "Git Revision ${GIT_REVISION}")

# MSVC compatibility with system headers
add_compile_definitions(NONAMELESSUNION)

# Make the detected version available as default version for all subprojects
set(FREERDP_DEFAULT_PROJECT_VERSION ${FREERDP_VERSION} CACHE STRING INTERNAL)

set(FREERDP_MAJOR_DIR "freerdp${FREERDP_VERSION_MAJOR}")
set(FREERDP_INCLUDE_DIR "include/${FREERDP_MAJOR_DIR}/")

option(WITH_SMARTCARD_EMULATE "Emulate smartcards instead of redirecting readers" ON)
if(WITH_SMARTCARD_EMULATE)
  add_compile_definitions(WITH_SMARTCARD_EMULATE)
  find_package(ZLIB REQUIRED)
endif()

option(WITH_FREERDP_DEPRECATED "Build FreeRDP deprecated symbols" OFF)
if(WITH_FREERDP_DEPRECATED)
  add_compile_definitions(WITH_FREERDP_DEPRECATED)
endif()

option(WITHOUT_FREERDP_3x_DEPRECATED "Build FreeRDP 3x deprecated symbols" OFF)
if(WITH_FREERDP_3x_DEPRECATED)
  message(WARNING "WITH_FREERDP_3x_DEPRECATED has been replaced with WITHOUT_FREERDP_3x_DEPRECATED")
  set(WITHOUT_FREERDP_3x_DEPRECATED OFF)
endif()

if(WITHOUT_FREERDP_3x_DEPRECATED)
  add_compile_definitions(WITHOUT_FREERDP_3x_DEPRECATED)
endif()

option(WITH_FREERDP_DEPRECATED_COMMANDLINE "Build FreeRDP deprecated command line options" OFF)
if(WITH_FREERDP_DEPRECATED_COMMANDLINE)
  add_compile_definitions(WITH_FREERDP_DEPRECATED_COMMANDLINE)
endif()

# Make paths absolute
if(CMAKE_INSTALL_PREFIX)
  get_filename_component(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}" ABSOLUTE)
endif()
if(FREERDP_EXTERNAL_PATH)
  get_filename_component(FREERDP_EXTERNAL_PATH "${FREERDP_EXTERNAL_PATH}" ABSOLUTE)
endif()

# Allow to search the host machine for git/ccache
if(CMAKE_CROSSCOMPILING)
  set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM BOTH)
endif(CMAKE_CROSSCOMPILING)

find_program(CCACHE ccache)
if(CCACHE AND WITH_CCACHE)
  if(NOT DEFINED CMAKE_C_COMPILER_LAUNCHER)
    set(CMAKE_C_COMPILER_LAUNCHER ${CCACHE})
  endif(NOT DEFINED CMAKE_C_COMPILER_LAUNCHER)
endif(CCACHE AND WITH_CCACHE)

if(CMAKE_CROSSCOMPILING)
  set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM ONLY)
endif(CMAKE_CROSSCOMPILING)
# /Allow to search the host machine for git/ccache

# Turn on solution folders (2.8.4+)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

option(CTEST_OUTPUT_ON_FAILURE ON "show verbose output on CTest failures")
if(BUILD_TESTING_INTERNAL)
  set(EXPORT_ALL_SYMBOLS ON CACHE BOOL "testing default" FORCE)
  add_compile_definitions(BUILD_TESTING_INTERNAL)
elseif(BUILD_TESTING)
  set(EXPORT_ALL_SYMBOLS OFF CACHE BOOL "testing default" FORCE)
endif()

include(ExportAllSymbols)

set(THREAD_PREFER_PTHREAD_FLAG TRUE)

if(NOT IOS)
  find_package(Threads REQUIRED)
endif()

if(WIN32)
  add_compile_definitions(UNICODE _UNICODE)
  add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
  add_compile_definitions(WIN32_LEAN_AND_MEAN)
  add_compile_definitions(_WINSOCK_DEPRECATED_NO_WARNINGS)

  set(CMAKE_DL_LIBS "")
  set(CMAKE_USE_RELATIVE_PATH ON)
  string(TIMESTAMP RC_VERSION_YEAR "%Y")

  if(NOT DEFINED CMAKE_WINDOWS_VERSION)
    set(CMAKE_WINDOWS_VERSION "WIN7")
  endif()

  if(CMAKE_WINDOWS_VERSION STREQUAL "WINXP")
    add_compile_definitions(WINVER=0x0501 _WIN32_WINNT=0x0501)
  elseif(CMAKE_WINDOWS_VERSION STREQUAL "WIN7")
    add_compile_definitions(WINVER=0x0601 _WIN32_WINNT=0x0601)
  elseif(CMAKE_WINDOWS_VERSION STREQUAL "WIN8")
    add_compile_definitions(WINVER=0x0602 _WIN32_WINNT=0x0602)
  elseif(CMAKE_WINDOWS_VERSION STREQUAL "WIN10")
    add_compile_definitions(WINVER=0x0A00 _WIN32_WINNT=0x0A00)
  endif()

  # Set product and vendor for dll and exe version information.
  set(RC_VERSION_VENDOR ${VENDOR})
  set(RC_VERSION_PRODUCT ${PRODUCT})
  set(RC_VERSION_PATCH ${BUILD_NUMBER})
  set(RC_VERSION_DESCRIPTION
      "${FREERDP_VERSION_FULL} ${GIT_REVISION} ${CMAKE_WINDOWS_VERSION} ${CMAKE_SYSTEM_PROCESSOR}"
  )

  if(FREERDP_EXTERNAL_SSL_PATH)
    set(OPENSSL_ROOT_DIR ${FREERDP_EXTERNAL_SSL_PATH})
  endif()
endif()

add_compile_definitions(FREERDP_EXPORTS)

# Mac OS X
if(APPLE)
  if(IOS)
    if(NOT FREERDP_IOS_EXTERNAL_SSL_PATH)
      message(
        STATUS
          "FREERDP_IOS_EXTERNAL_SSL_PATH not set! Required if openssl is not found in the iOS SDK (which usually isn't"
      )
    endif()
    set(CMAKE_FIND_ROOT_PATH ${CMAKE_FIND_ROOT_PATH} ${FREERDP_IOS_EXTERNAL_SSL_PATH})
    set_property(GLOBAL PROPERTY XCODE_ATTRIBUTE_SKIP_INSTALL YES)
  endif(IOS)

  # Temporarily disabled, causes the cmake script to be reexecuted, causing the compilation to fail.
  # Workaround: specify the parameter in the command-line
  #	if(WITH_CLANG)
  #		set(CMAKE_C_COMPILER "clang")
  #	endif()

  if(WITH_VERBOSE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -v")
  endif()
endif(APPLE)

# Android
if(ANDROID)
  set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS ${ANDROID_LIBRARY_USE_LIB64_PATHS})

  if(ANDROID_ABI STREQUAL arm64-v8a)
    include(CheckCCompilerFlag)
    check_c_compiler_flag("-mfloat-abi=softfp" ABI_SOFTFP_SUPPORTED)

    if(ABI_SOFTFP_SUPPORTED)
      # https://github.com/android/ndk/issues/910
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfloat-abi=softfp")
    endif()
  endif()

  add_compile_definitions("$<$<CONFIG:Debug>:NDK_DEBUG=1>")

  # NOTE: Manually add -gdwarf-3, as newer toolchains default to -gdwarf-4,
  #       which is not supported by the gdbserver binary shipped with
  #       the android NDK (tested with r9b)
  add_compile_options("$<$<CONFIG:Debug>:-gdwarf-3>")
  add_link_options(-llog)

  # CMAKE_PREFIX_PATH detection is broken in most Android toolchain files
  # Append it to CMAKE_FIND_ROOT_PATH and avoid potential duplicates
  list(APPEND CMAKE_FIND_ROOT_PATH ${CMAKE_PREFIX_PATH})
  list(REMOVE_DUPLICATES CMAKE_FIND_ROOT_PATH)

  if(NOT FREERDP_EXTERNAL_PATH)
    if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/external/")
      set(FREERDP_EXTERNAL_PATH "${CMAKE_CURRENT_SOURCE_DIR}/external/")
    else()
      message(STATUS "FREERDP_EXTERNAL_PATH not set!")
    endif()
  endif()

  list(APPEND CMAKE_INCLUDE_PATH ${FREERDP_EXTERNAL_PATH}/${ANDROID_ABI}/include)
  list(APPEND CMAKE_LIBRARY_PATH ${FREERDP_EXTERNAL_PATH}/${ANDROID_ABI}/)
  set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY BOTH)
  set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE BOTH)

  if(WITH_GPROF)
    configure_file(
      ${PROJECT_SOURCE_DIR}/scripts/gprof_generate.sh.in ${PROJECT_BINARY_DIR}/scripts/gprof_generate.sh @ONLY
    )
  endif(WITH_GPROF)
endif()

if(UNIX OR CYGWIN)
  set(WAYLAND_FEATURE_TYPE "RECOMMENDED")
else()
  set(WAYLAND_FEATURE_TYPE "DISABLED")
endif()

if(WITH_PCSC_WINPR)
  find_package(PCSCWinPR)
endif()

set(WAYLAND_FEATURE_PURPOSE "Wayland")
set(WAYLAND_FEATURE_DESCRIPTION "Wayland client")

set(OPENSSL_FEATURE_TYPE "REQUIRED")
set(OPENSSL_FEATURE_PURPOSE "cryptography")
set(OPENSSL_FEATURE_DESCRIPTION "encryption, certificate validation, hashing functions")

set(MBEDTLS_FEATURE_TYPE "OPTIONAL")
set(MBEDTLS_FEATURE_PURPOSE "cryptography")
set(MBEDTLS_FEATURE_DESCRIPTION "encryption, certificate validation, hashing functions")

set(PCSC_FEATURE_TYPE "RECOMMENDED")
set(PCSC_FEATURE_PURPOSE "smart card")
set(PCSC_FEATURE_DESCRIPTION "smart card device redirection")

set(OPENH264_FEATURE_TYPE "OPTIONAL")
set(OPENH264_FEATURE_PURPOSE "codec")
set(OPENH264_FEATURE_DESCRIPTION "use OpenH264 library")

set(GSM_FEATURE_TYPE "OPTIONAL")
set(GSM_FEATURE_PURPOSE "codec")
set(GSM_FEATURE_DESCRIPTION "GSM audio codec library")

set(LAME_FEATURE_TYPE "OPTIONAL")
set(LAME_FEATURE_PURPOSE "codec")
set(LAME_FEATURE_DESCRIPTION "lame MP3 audio codec library")

set(FAAD2_FEATURE_TYPE "OPTIONAL")
set(FAAD2_FEATURE_PURPOSE "codec")
set(FAAD2_FEATURE_DESCRIPTION "FAAD2 AAC audio codec library")

set(FAAC_FEATURE_TYPE "OPTIONAL")
set(FAAC_FEATURE_PURPOSE "codec")

=== client/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP Clients
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Clients

include(CMakeDependentOption)
include(InstallFreeRDPDesktop)

if(WITH_CLIENT_COMMON)
  add_subdirectory(common)
endif()

if(FREERDP_VENDOR AND WITH_CLIENT)
  if(WIN32 AND NOT UWP)
    option(WITH_CLIENT_WINDOWS "Build native windows client" ON)
    if(WITH_CLIENT_WINDOWS)
      add_subdirectory(Windows)
    endif()
  else()
    if(WITH_SAMPLE)
      add_subdirectory(Sample)
    endif()
  endif()

  if(WITH_CLIENT_SDL)
    add_subdirectory(SDL)
  endif()

  if(WITH_X11)
    add_subdirectory(X11)
  endif()

  if(WITH_WAYLAND AND WAYLAND_FOUND)
    add_subdirectory(Wayland)
  endif()

  if(APPLE)
    if(IOS)
      option(WITH_CLIENT_IOS "Build native iOS client" ON)
      if(WITH_CLIENT_IOS)
        if(NOT WITHOUT_FREERDP_3x_DEPRECATED)
          if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/iOS")
            message(STATUS "Adding iOS client")
            add_subdirectory(iOS)
          endif()
        endif()
      endif()
    else()
      option(WITH_CLIENT_MAC "Build native mac client" ON)
      if(WITH_CLIENT_MAC)
        add_subdirectory(Mac)
      endif()
    endif()
  endif()

  if(ANDROID)
    message(STATUS "Android client module is built with Android Studio project")
  endif()
endif()

# Pick up other clients
if(WITH_CLIENT)
  set(FILENAME "ModuleOptions.cmake")
  file(GLOB FILEPATHS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*/${FILENAME}")

  foreach(FILEPATH ${FILEPATHS})
    if(${FILEPATH} MATCHES "^([^/]*)/+${FILENAME}")
      string(REGEX REPLACE "^([^/]*)/+${FILENAME}" "\\1" FREERDP_CLIENT ${FILEPATH})
      set(FREERDP_CLIENT_ENABLED 0)
      include(${FILEPATH})
      if(FREERDP_CLIENT_ENABLED)
        if(NOT (${FREERDP_CLIENT_VENDOR} MATCHES "FreeRDP"))
          list(APPEND FREERDP_EXTRA_CLIENTS ${FREERDP_CLIENT})
          if(${FREERDP_CLIENT_VENDOR} MATCHES "${VENDOR}")
            set(CLIENT_VENDOR_PATH "client/${FREERDP_CLIENT}" PARENT_SCOPE)
          endif()
        endif()
      endif()
    endif()
  endforeach()

  foreach(FREERDP_CLIENT ${FREERDP_EXTRA_CLIENTS})
    add_subdirectory(${FREERDP_CLIENT})
  endforeach()
endif()

if(WITH_FUSE)
  list(APPEND FREERDP_CLIENT_PC_PRIVATE_LIBS "-lfuse3")
endif()

list(JOIN FREERDP_CLIENT_PC_PRIVATE_LIBS " " FREERDP_CLIENT_PC_PRIVATE_LIBS)
include(pkg-config-install-prefix)
cleaning_configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/freerdp-client.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/freerdp-client${FREERDP_VERSION_MAJOR}.pc @ONLY
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/freerdp-client${FREERDP_VERSION_MAJOR}.pc
        DESTINATION ${PKG_CONFIG_PC_INSTALL_DIR}
)

export(PACKAGE freerdp-client)

setfreerdpcmakeinstalldir(FREERDP_CLIENT_CMAKE_INSTALL_DIR "FreeRDP-Client${FREERDP_VERSION_MAJOR}")

configure_package_config_file(
  FreeRDP-ClientConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/FreeRDP-ClientConfig.cmake
  INSTALL_DESTINATION ${FREERDP_CLIENT_CMAKE_INSTALL_DIR} PATH_VARS FREERDP_INCLUDE_DIR
)

write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/FreeRDP-ClientConfigVersion.cmake VERSION ${FREERDP_VERSION}
  COMPATIBILITY SameMajorVersion
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/FreeRDP-ClientConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/FreeRDP-ClientConfigVersion.cmake
        DESTINATION ${FREERDP_CLIENT_CMAKE_INSTALL_DIR}
)

install(EXPORT FreeRDP-ClientTargets DESTINATION ${FREERDP_CLIENT_CMAKE_INSTALL_DIR})

=== uwac/CMakeLists.txt ===
# UWAC: Using Wayland As Client
# cmake build script
#
# Copyright 2015 David FORT <contact@hardening-consulting.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Soname versioning
set(UWAC_VERSION_MAJOR "0")
set(UWAC_VERSION_MINOR "2")
set(UWAC_VERSION_REVISION "0")
set(UWAC_VERSION "${UWAC_VERSION_MAJOR}.${UWAC_VERSION_MINOR}.${UWAC_VERSION_REVISION}")
set(UWAC_VERSION_FULL "${UWAC_VERSION}")
set(UWAC_API_VERSION "${UWAC_VERSION_MAJOR}")

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../cmake/)
if(NOT FREERDP_UNIFIED_BUILD)
  cmake_minimum_required(VERSION 3.13)
  project(uwac VERSION ${UWAC_VERSION} LANGUAGES C)

  include(ProjectCStandard)

  include(ExportAllSymbols)
endif()

option(UWAC_FORCE_STATIC_BUILD "Force UWAC to be build as static library (recommended)" OFF)
option(UWAC_HAVE_PIXMAN_REGION "Use PIXMAN or FreeRDP for region calculations" "NOT FREERDP_UNIFIED_BUILD")

# Include our extra modules
include(CommonConfigOptions)

include(CheckFunctionExists)
check_function_exists(strerror_r UWAC_HAVE_STRERROR_R)

# Check for cmake compatibility (enable/disable features)
include(FindFeature)

if(UWAC_FORCE_STATIC_BUILD)
  set(BUILD_SHARED_LIBS OFF)
else()
  include(SetFreeRDPCMakeInstallDir)
  include(CMakePackageConfigHelpers)
endif()

if(NOT IOS)
  include(CheckIncludeFiles)
  check_include_files(stdbool.h UWAC_HAVE_STDBOOL_H)
  if(NOT UWAC_HAVE_STDBOOL_H)
    include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/../compat/stdbool)
  endif()
endif()

# Find required libraries
if(UWAC_HAVE_PIXMAN_REGION)
  find_package(PkgConfig REQUIRED)
  pkg_check_modules(pixman REQUIRED pixman-1)
  include_directories(SYSTEM ${pixman_INCLUDE_DIRS})
elseif(FREERDP_UNIFIED_BUILD)
  include_directories(${PROJECT_SOURCE_DIR}/winpr/include)
  include_directories(${PROJECT_BINARY_DIR}/winpr/include)
  include_directories(${PROJECT_SOURCE_DIR}/include)
  include_directories(${PROJECT_BINARY_DIR}/include)
else()
  find_package(WinPR 3 REQUIRED)
  find_package(FreeRDP 3 REQUIRED)
  include_directories(SYSTEM ${WinPR_INCLUDE_DIR})
  include_directories(SYSTEM ${FreeRDP_INCLUDE_DIR})
endif()

set(WAYLAND_FEATURE_PURPOSE "Wayland")
set(WAYLAND_FEATURE_DESCRIPTION "Wayland client")
set(WAYLAND_FEATURE_TYPE "REQUIRED")
find_feature(Wayland ${WAYLAND_FEATURE_TYPE} ${WAYLAND_FEATURE_PURPOSE} ${WAYLAND_FEATURE_DESCRIPTION})

set(UWAC_INCLUDE_DIR include/uwac${UWAC_API_VERSION})

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR}/include)

add_subdirectory(libuwac)
add_subdirectory(templates)
add_subdirectory(include)

=== winpr/CMakeLists.txt ===
# WinPR: Windows Portable Runtime
# winpr cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Include our extra modules
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../cmake/)

if(NOT FREERDP_UNIFIED_BUILD)
  cmake_minimum_required(VERSION 3.13)

  if(POLICY CMP0091)
    cmake_policy(SET CMP0091 NEW)
  endif()
  project(WinPR LANGUAGES C)

  include(ProjectCStandard)
  include(CommonConfigOptions)
  include(ConfigOptions)

  # Enable coverity related pragma definitions
  if(COVERITY_BUILD)
    add_compile_definitions(COVERITY_BUILD)
  endif()

  # Default to build shared libs
  include(ExportAllSymbols)
  if(WITH_DEBUG_ALL)
    message(
      WARNING
        "WITH_DEBUG_ALL=ON, the build will be slow and might leak sensitive information, do not use with release builds!"
    )
    set(DEFAULT_DEBUG_OPTION "ON" CACHE INTERNAL "debug default")
  else()
    set(DEFAULT_DEBUG_OPTION "OFF" CACHE INTERNAL "debug default")
  endif()

  # MSVC compatibility with system headers
  add_compile_definitions(NONAMELESSUNION)
endif()

if(WIN32 AND NOT UWP)
  set(NATIVE_SSPI ON)
endif()

if((NOT ANDROID AND NOT IOS AND NOT UWP) AND NOT WITH_MBEDTLS)
  set(TOOLS_DEFAULT ON)
else()
  set(TOOLS_DEFAULT OFF)
endif()

if(WITH_MBEDTLS)
  set(WITH_INTERNAL_RC4_DEFAULT ON)
  set(WITH_INTERNAL_MD4_DEFAULT ON)
  set(WITH_INTERNAL_MD5_DEFAULT OFF)
else()
  set(WITH_INTERNAL_RC4_DEFAULT OFF)
  set(WITH_INTERNAL_MD4_DEFAULT OFF)
  set(WITH_INTERNAL_MD5_DEFAULT OFF)
endif()

option(WITH_WINPR_TOOLS "Build WinPR helper binaries" ${TOOLS_DEFAULT})
option(WITH_WINPR_DEPRECATED "Build WinPR deprecated symbols" OFF)
option(WITH_DEBUG_THREADS "Print thread debug messages, enables handle dump" ${DEFAULT_DEBUG_OPTION})
option(WITH_DEBUG_EVENTS "Print event debug messages, enables handle dump" ${DEFAULT_DEBUG_OPTION})
option(WITH_DEBUG_SYMBOLS "Pack debug symbols to installer" OFF)
option(WITH_NATIVE_SSPI "Use native SSPI modules" ${NATIVE_SSPI})
option(WITH_SMARTCARD_INSPECT "Enable SmartCard API Inspector" OFF)
option(WITH_DEBUG_MUTEX "Print mutex debug messages" ${DEFAULT_DEBUG_OPTION})
option(WITH_INTERNAL_RC4 "Use compiled in rc4 functions instead of OpenSSL/MBedTLS" ${WITH_INTERNAL_RC4_DEFAULT})
option(WITH_INTERNAL_MD4 "Use compiled in md4 hash functions instead of OpenSSL/MBedTLS" ${WITH_INTERNAL_MD4_DEFAULT})
option(WITH_INTERNAL_MD5 "Use compiled in md5 hash functions instead of OpenSSL/MBedTLS" ${WITH_INTERNAL_MD5_DEFAULT})
option(WITH_UNICODE_BUILTIN "Use built-in Unicode conversion (don't use system-provided libraries)" OFF)
option(WINPR_USE_LEGACY_RESOURCE_DIR "use a resource directory of <base>/WinPR instead of <base>/<product>" ON)
option(WINPR_USE_VENDOR_PRODUCT_CONFIG_DIR
       "use a configuration <base>/<product>/<vendor>/ subdirectory instead of </base>/winpr" OFF
)

# This option MUST be off to avoid symbol conflicts when loading an external SSPI module library
option(SSPI_DLL "Define and export SSPI API symbols for usage as a Windows SSPI DLL replacement" OFF)

if(SSPI_DLL)
  add_compile_definitions("SSPI_DLL")
endif()

option(WITH_DEBUG_NTLM "Print NTLM debug messages" ${DEFAULT_DEBUG_OPTION})
if(WITH_DEBUG_NTLM)
  message(WARNING "WITH_DEBUG_NTLM=ON, the build might leak sensitive information, do not use with release builds!")
endif()

option(WITH_DEBUG_NLA "Print authentication related debug messages." ${DEFAULT_DEBUG_OPTION})
if(WITH_DEBUG_NLA)
  message(WARNING "WITH_DEBUG_NLA=ON, the build might leak sensitive information, do not use with release builds!")
endif()

if(WITH_WINPR_DEPRECATED)
  add_compile_definitions(WITH_WINPR_DEPRECATED)
endif()

# Include cmake modules
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CheckStructHasMember)
include(TestBigEndian)

# Check for cmake compatibility (enable/disable features)
include(CheckCmakeCompat)
include(FindFeature)
include(FeatureSummary)
include(CheckCCompilerFlag)
include(InstallFreeRDPMan)
include(SetFreeRDPCMakeInstallDir)
include(CMakePackageConfigHelpers)

if(NOT WIN32)
  add_compile_definitions(WINPR_CRITICAL_SECTION_DISABLE_SPINCOUNT)
endif()

# Soname versioning
set(VERSION_REGEX "^(.*)([0-9]+)\\.([0-9]+)\\.([0-9]+)-?(.*)")
set(RAW_VERSION_STRING "3.15.0")
if(EXISTS "${PROJECT_SOURCE_DIR}/.source_tag")
  file(READ ${PROJECT_SOURCE_DIR}/.source_tag RAW_VERSION_STRING)
elseif(USE_VERSION_FROM_GIT_TAG)
  git_get_exact_tag(_GIT_TAG --tags --always)
  if(NOT ${_GIT_TAG} STREQUAL "n/a")
    string(REGEX MATCH ${VERSION_REGEX} FOUND_TAG "${_GIT_TAG}")
    if(FOUND_TAG)
      set(RAW_VERSION_STRING ${_GIT_TAG})
    endif()
  endif()
endif()
string(STRIP ${RAW_VERSION_STRING} RAW_VERSION_STRING)

string(REGEX REPLACE "${VERSION_REGEX}" "\\2" WINPR_VERSION_MAJOR "${RAW_VERSION_STRING}")
string(REGEX REPLACE "${VERSION_REGEX}" "\\3" WINPR_VERSION_MINOR "${RAW_VERSION_STRING}")
string(REGEX REPLACE "${VERSION_REGEX}" "\\4" WINPR_VERSION_REVISION "${RAW_VERSION_STRING}")
string(REGEX REPLACE "${VERSION_REGEX}" "\\5" WINPR_VERSION_SUFFIX "${RAW_VERSION_STRING}")

set(WINPR_VERSION "${WINPR_VERSION_MAJOR}.${WINPR_VERSION_MINOR}.${WINPR_VERSION_REVISION}")
set(WINPR_API_VERSION "${WINPR_VERSION_MAJOR}")
if(WINPR_VERSION_SUFFIX)
  set(WINPR_VERSION_FULL "${WINPR_VERSION}-${WINPR_VERSION_SUFFIX}")
else()
  set(WINPR_VERSION_FULL "${WINPR_VERSION}")
endif()

set(WINPR_RESOURCE_ROOT ${CMAKE_INSTALL_FULL_DATAROOTDIR})

# Quite the compatibility show here (newest to oldest):
# * <base>[/<vendor>]/<product>[<version>]
# * <base>[/<vendor>]/WinPR[<version>]
# * <base>/winpr
if(WINPR_USE_LEGACY_RESOURCE_DIR)
  string(APPEND WINPR_RESOURCE_ROOT "/WinPR")
else()
  if(WINPR_USE_VENDOR_PRODUCT_CONFIG_DIR)
    string(APPEND WINPR_RESOURCE_ROOT "/${VENDOR}/")
  endif()
  string(APPEND WINPR_RESOURCE_ROOT "/${PRODUCT}")
  if(WITH_RESOURCE_VERSIONING)
    string(APPEND WINPR_RESOURCE_ROOT "${WINPR_VERSION_MAJOR}")
  endif()
endif()

include(CheckTypeSize)
set(CMAKE_EXTRA_INCLUDE_FILES "sys/types.h")
check_type_size(ssize_t SSIZE_T)

set(CMAKE_EXTRA_INCLUDE_FILES "BaseTsd.h")
check_type_size(SSIZE_T WIN_SSIZE_T)

set(WINPR_HAVE_SSIZE_T ${HAVE_SSIZE_T})
set(WINPR_HAVE_WIN_SSIZE_T ${HAVE_WIN_SSIZE_T})

check_symbol_exists(strndup string.h WINPR_HAVE_STRNDUP)
check_include_files(unistd.h WINPR_HAVE_UNISTD_H)
check_include_files(execinfo.h WINPR_HAVE_EXECINFO_HEADER)
if(WINPR_HAVE_EXECINFO_HEADER)
  check_symbol_exists(backtrace execinfo.h WINPR_HAVE_EXECINFO_BACKTRACE)
  check_symbol_exists(backtrace_symbols execinfo.h WINPR_HAVE_EXECINFO_BACKTRACE_SYMBOLS)
  check_symbol_exists(backtrace_symbols_fd execinfo.h WINPR_HAVE_EXECINFO_BACKTRACE_SYMBOLS_FD)

  # Some implementations (e.g. Android NDK API < 33) provide execinfo.h but do not define
  # the backtrace functions. Disable detection for these cases
  if(WINPR_HAVE_EXECINFO_BACKTRACE AND WINPR_HAVE_EXECINFO_BACKTRACE_SYMBOLS
     AND WINPR_HAVE_EXECINFO_BACKTRACE_SYMBOLS_FD
  )
    set(WINPR_HAVE_EXECINFO_H ON)
  endif()
endif()

check_include_files(stdint.h WINPR_HAVE_STDINT_H)
check_include_files(inttypes.h WINPR_HAVE_INTTYPES_H)
check_include_files(stdbool.h WINPR_HAVE_STDBOOL_H)

if(NOT WINPR_HAVE_INTTYPES_H OR NOT WINPR_HAVE_STDINT_H OR NOT WINPR_HAVE_STDBOOL_H)
  message(FATAL_ERROR "c11 headers stdint.h, stdbool.h and inttypes.h are required, giving up")
endif()

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)

if(NOT IOS)
  find_package(Threads REQUIRED)
endif()

# Include files
if(NOT IOS)
  check_include_files(fcntl.h WINPR_HAVE_FCNTL_H)
  check_include_files(aio.h WINPR_HAVE_AIO_H)
  check_include_files(sys/timerfd.h WINPR_HAVE_SYS_TIMERFD_H)
  check_include_files(unistd.h WINPR_HAVE_UNISTD_H)
  check_include_files(inttypes.h WINPR_HAVE_INTTYPES_H)
  check_include_files(sys/filio.h WINPR_HAVE_SYS_FILIO_H)
  check_include_files(sys/sockio.h WINPR_HAVE_SYS_SOCKIO_H)
  check_include_files(syslog.h WINPR_HAVE_SYSLOG_H)
  check_include_files(sys/select.h WINPR_HAVE_SYS_SELECT_H)
  check_include_files(sys/eventfd.h WINPR_HAVE_SYS_EVENTFD_H)
  check_include_files(unwind.h WINPR_HAVE_UNWIND_H)
  if(WINPR_HAVE_SYS_EVENTFD_H)
    check_symbol_exists(eventfd_read sys/eventfd.h WITH_EVENTFD_READ_WRITE)
  endif()

  include(CheckFunctionExists)
  check_function_exists(strerror_r WINPR_HAVE_STRERROR_R)
  check_function_exists(getlogin_r WINPR_HAVE_GETLOGIN_R)
  check_function_exists(getpwuid_r WINPR_HAVE_GETPWUID_R)
  check_struct_has_member("struct tm" tm_gmtoff time.h WINPR_HAVE_TM_GMTOFF)
else()
  set(WINPR_HAVE_FCNTL_H 1)
  set(WINPR_HAVE_UNISTD_H 1)
  set(WINPR_HAVE_INTTYPES_H 1)
  set(WINPR_HAVE_SYS_FILIO_H 1)
  set(WINPR_HAVE_TM_GMTOFF 1)
endif()

if(UNIX OR CYGWIN)
  if(FREEBSD)
    list(APPEND CMAKE_REQUIRED_INCLUDES ${EPOLLSHIM_INCLUDE_DIR})
  endif()
  if(FREEBSD)
    list(REMOVE_ITEM CMAKE_REQUIRED_INCLUDES ${EPOLLSHIM_INCLUDE_DIR})
  endif()
  option(WITH_POLL "Check for and include poll.h" ON)
  if(WITH_POLL)
    check_include_files(poll.h WINPR_HAVE_POLL_H)
  endif()
endif()

if(NOT WIN32 AND NOT IOS)
  if(NOT WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_LIB)
    check_library_exists(pthreads pthread_mutex_timedlock "" WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_LIBS)
  endif(NOT WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_LIB)

  if(NOT WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_SYMBOL)
    check_library_exists(pthread pthread_mutex_timedlock "" WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_LIB)
  endif(NOT WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_SYMBOL)

  list(APPEND CMAKE_REQUIRED_LIBRARIES pthread)
  check_symbol_exists(pthread_mutex_timedlock pthread.h WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_SYMBOL)

  if(WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_SYMBOL OR WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_LIB
     OR WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_LIBS
  )
    set(WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK ON)
  endif(WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_SYMBOL OR WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_LIB
        OR WINPR_HAVE_PTHREAD_MUTEX_TIMEDLOCK_LIBS
  )
  list(REMOVE_ITEM CMAKE_REQUIRED_LIBRARIES pthread)
endif()

set(OPENSSL_FEATURE_TYPE "RECOMMENDED")
set(OPENSSL_FEATURE_PURPOSE "cryptography")
set(OPENSSL_FEATURE_DESCRIPTION "encryption, certificate validation, hashing functions")

set(MBEDTLS_FEATURE_TYPE "OPTIONAL")
set(MBEDTLS_FEATURE_PURPOSE "cryptography")
set(MBEDTLS_FEATURE_DESCRIPTION "encryption, certificate validation, hashing functions")

option(WITH_LIBRESSL "build with LibreSSL" OFF)
if(WITH_LIBRESSL)
  find_package(LibreSSL REQUIRED)
  set(OPENSSL_INCLUDE_DIR ${LIBRESSL_INCLUDE_DIR})
  set(OPENSSL_LIBRARIES ${LIBRESSL_LIBRARIES})
  set(OPENSSL_CRYPTO_LIBRARIES ${LIBRESSL_LIBRARIES})
  set(WITH_OPENSSL ON)
  set(OPENSSL_FOUND ON)
  add_compile_definitions("WITH_LIBRESSL")
  add_compile_definitions("WITH_OPENSSL")
else()
  find_feature(OpenSSL ${OPENSSL_FEATURE_TYPE} ${OPENSSL_FEATURE_PURPOSE} ${OPENSSL_FEATURE_DESCRIPTION})
  find_feature(MbedTLS ${MBEDTLS_FEATURE_TYPE} ${MBEDTLS_FEATURE_PURPOSE} ${MBEDTLS_FEATURE_DESCRIPTION})
endif()

if(NOT OPENSSL_FOUND AND NOT MBEDTLS_FOUND AND NOT LibreSSL_FOUND)
  message(FATAL_ERROR "OpenSSL or MBedTLS are required, none enabled/found")
endif()

if(WITH_OPENSSL AND OPENSSL_FOUND)
  add_compile_definitions("WITH_OPENSSL")
endif()

if(WITH_MBEDTLS AND MBEDTLS_FOUND)
  add_compile_definitions("WITH_MBEDTLS")
endif()

enable_testing()

if(MSVC)
  set(TESTING_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}")
else()
  set(TESTING_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/Testing")
endif()

=== channels/disp/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

define_channel("disp")

if(WITH_CLIENT_CHANNELS)
  add_channel_client(${MODULE_PREFIX} ${CHANNEL_NAME})
endif()

if(WITH_SERVER_CHANNELS)
  add_channel_server(${MODULE_PREFIX} ${CHANNEL_NAME})
endif()

=== channels/drdynvc/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

define_channel("drdynvc")

if(WITH_CLIENT_CHANNELS)
  add_channel_client(${MODULE_PREFIX} ${CHANNEL_NAME})
endif()

if(WITH_SERVER_CHANNELS)
  add_channel_server(${MODULE_PREFIX} ${CHANNEL_NAME})
endif()

=== libfreerdp/crypto/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# libfreerdp-crypto cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(MODULE_NAME "freerdp-crypto")
set(MODULE_PREFIX "FREERDP_CRYPTO")

freerdp_module_add(
  er.c
  der.c
  ber.c
  per.c
  base64.c
  x509_utils.c
  x509_utils.h
  cert_common.h
  cert_common.c
  privatekey.c
  privatekey.h
  certificate.c
  certificate.h
  certificate_data.c
  certificate_store.c
  crypto.c
  tls.c
  tls.h
  opensslcompat.c
)

freerdp_include_directory_add(${OPENSSL_INCLUDE_DIR})

freerdp_library_add(${OPENSSL_LIBRARIES})

if(MBEDTLS_FOUND)
  freerdp_include_directory_add(${MBEDTLS_INCLUDE_DIR})
  freerdp_library_add(${MBEDTLS_LIBRARIES})
endif()

if(WIN32)
  freerdp_library_add(ws2_32)
endif()

if(BUILD_TESTING_INTERNAL OR BUILD_TESTING)
  add_subdirectory(test)
endif()

=== rdtk/librdtk/CMakeLists.txt ===
# RdTk: Remote Desktop Toolkit
#
# Copyright 2014 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(MODULE_NAME "rdtk")
set(MODULE_PREFIX "RDTK")

set(${MODULE_PREFIX}_SRCS
    rdtk_resources.c
    rdtk_resources.h
    rdtk_surface.c
    rdtk_surface.h
    rdtk_font.c
    rdtk_font.h
    rdtk_button.c
    rdtk_button.h
    rdtk_label.c
    rdtk_label.h
    rdtk_nine_patch.c
    rdtk_nine_patch.h
    rdtk_text_field.c
    rdtk_text_field.h
    rdtk_engine.c
    rdtk_engine.h
)

addtargetwithresourcefile(${MODULE_NAME} FALSE "${RDTK_VERSION}" ${MODULE_PREFIX}_SRCS)

list(APPEND ${MODULE_PREFIX}_LIBS winpr)

target_include_directories(${MODULE_NAME} INTERFACE $<INSTALL_INTERFACE:include>)
target_link_libraries(${MODULE_NAME} PRIVATE ${${MODULE_PREFIX}_LIBS})

set_property(TARGET ${MODULE_NAME} PROPERTY FOLDER "RdTk")

if(BUILD_TESTING_INTERNAL OR BUILD_TESTING)
  add_subdirectory(test)
endif()

if(NOT RDTK_FORCE_STATIC_BUILD)
  install(TARGETS ${MODULE_NAME} COMPONENT libraries EXPORT rdtk ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  )
endif()

=== server/common/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP Server Common
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(MODULE_NAME "freerdp-server")
set(MODULE_PREFIX "FREERDP_SERVER")

set(${MODULE_PREFIX}_SRCS server.c)

foreach(FREERDP_CHANNELS_SERVER_SRC ${FREERDP_CHANNELS_SERVER_SRCS})
  set(${MODULE_PREFIX}_SRCS ${${MODULE_PREFIX}_SRCS} "${FREERDP_CHANNELS_SERVER_SRC}")
endforeach()

if(MSVC)
  set(${MODULE_PREFIX}_SRCS ${${MODULE_PREFIX}_SRCS})
endif()

addtargetwithresourcefile(${MODULE_NAME} FALSE "${FREERDP_VERSION}" ${MODULE_PREFIX}_SRCS)

target_include_directories(${MODULE_NAME} INTERFACE $<INSTALL_INTERFACE:include>)
target_link_libraries(${MODULE_NAME} PRIVATE ${FREERDP_CHANNELS_SERVER_LIBS})
target_link_libraries(${MODULE_NAME} PUBLIC winpr freerdp)

install(TARGETS ${MODULE_NAME} COMPONENT libraries EXPORT FreeRDP-ServerTargets
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

set_property(TARGET ${MODULE_NAME} PROPERTY FOLDER "Server/Common")

=== winpr/tools/CMakeLists.txt ===
# WinPR: Windows Portable Runtime
# winpr cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
# Copyright 2016  Thincast Technologies GmbH
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Soname versioning - use winpr version
set(WINPR_TOOLS_VERSION_MAJOR "${WINPR_VERSION_MAJOR}")
set(WINPR_TOOLS_VERSION_MINOR "${WINPR_VERSION_MINOR}")
set(WINPR_TOOLS_VERSION_REVISION "${WINPR_VERSION_REVISION}")

set(WINPR_TOOLS_API_VERSION "${WINPR_TOOLS_VERSION_MAJOR}")
set(WINPR_TOOLS_VERSION "${WINPR_TOOLS_VERSION_MAJOR}.${WINPR_TOOLS_VERSION_MINOR}.${WINPR_TOOLS_VERSION_REVISION}")
set(WINPR_TOOLS_VERSION_FULL "${WINPR_TOOLS_VERSION}")
set(WINPR_TOOLS_API_VERSION "${WINPR_TOOLS_VERSION_MAJOR}")

set(WINPR_TOOLS_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(WINPR_TOOLS_SRCS "")
set(WINPR_TOOLS_LIBS "")
set(WINPR_TOOLS_INCLUDES "")
set(WINPR_TOOLS_DEFINITIONS "")

macro(winpr_tools_module_add)
  file(RELATIVE_PATH _relPath "${WINPR_TOOLS_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}")
  foreach(_src ${ARGN})
    if(_relPath)
      list(APPEND WINPR_TOOLS_SRCS "${_relPath}/${_src}")
    else()
      list(APPEND WINPR_TOOLS_SRCS "${_src}")
    endif()
  endforeach()
  if(_relPath)
    set(WINPR_TOOLS_SRCS ${WINPR_TOOLS_SRCS} PARENT_SCOPE)
  endif()
endmacro()

macro(winpr_tools_include_directory_add)
  file(RELATIVE_PATH _relPath "${WINPR_TOOLS_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}")
  foreach(_inc ${ARGN})
    if(IS_ABSOLUTE ${_inc})
      list(APPEND WINPR_TOOLS_INCLUDES "${_inc}")
    else()
      if(_relPath)
        list(APPEND WINPR_TOOLS_INCLUDES "${_relPath}/${_inc}")
      else()
        list(APPEND WINPR_TOOLS_INCLUDES "${_inc}")
      endif()
    endif()
  endforeach()
  if(_relPath)
    set(WINPR_TOOLS_INCLUDES ${WINPR_TOOLS_INCLUDES} PARENT_SCOPE)
  endif()
endmacro()

macro(winpr_tools_library_add)
  foreach(_lib ${ARGN})
    list(APPEND WINPR_TOOLS_LIBS "${_lib}")
  endforeach()
  set(WINPR_TOOLS_LIBS ${WINPR_TOOLS_LIBS} PARENT_SCOPE)
endmacro()

macro(winpr_tools_definition_add)
  foreach(_define ${ARGN})
    list(APPEND WINPR_TOOLS_DEFINITONS "${_define}")
  endforeach()
  set(WINPR_TOOLS_DEFINITONS ${WINPR_TOOLS_DEFINITONS} PARENT_SCOPE)
endmacro()

add_subdirectory(makecert)

set(MODULE_NAME winpr-tools)
list(REMOVE_DUPLICATES WINPR_TOOLS_DEFINITIONS)
list(REMOVE_DUPLICATES WINPR_TOOLS_INCLUDES)
include_directories(${WINPR_TOOLS_INCLUDES})

addtargetwithresourcefile(${MODULE_NAME} FALSE "${WINPR_VERSION}" WINPR_TOOLS_SRCS)

add_compile_definitions(${WINPR_DEFINITIONS})
target_include_directories(${MODULE_NAME} INTERFACE $<INSTALL_INTERFACE:include/winpr${WINPR_VERSION_MAJOR}>)
target_link_libraries(${MODULE_NAME} PRIVATE ${WINPR_TOOLS_LIBS})

install(TARGETS ${MODULE_NAME} COMPONENT libraries EXPORT WinPR-toolsTargets ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

set_property(TARGET ${MODULE_NAME} PROPERTY FOLDER "WinPR/Tools")

# Add all command line utilities
option(WITH_WINPR_TOOLS_CLI "Build winpr-tools cli programs" ON)
if(WITH_WINPR_TOOLS_CLI)
  add_subdirectory(makecert-cli)
  add_subdirectory(hash-cli)
endif()

include(pkg-config-install-prefix)
cleaning_configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/winpr-tools.pc.in ${CMAKE_CURRENT_BINARY_DIR}/winpr-tools${WINPR_TOOLS_VERSION_MAJOR}.pc
  @ONLY
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/winpr-tools${WINPR_TOOLS_VERSION_MAJOR}.pc
        DESTINATION ${PKG_CONFIG_PC_INSTALL_DIR}
)

export(PACKAGE ${MODULE_NAME})

setfreerdpcmakeinstalldir(WINPR_CMAKE_INSTALL_DIR "WinPR-tools${WINPR_VERSION_MAJOR}")

configure_package_config_file(
  WinPR-toolsConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/WinPR-toolsConfig.cmake
  INSTALL_DESTINATION ${WINPR_CMAKE_INSTALL_DIR} PATH_VARS WINPR_INCLUDE_DIR
)

write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/WinPR-toolsConfigVersion.cmake VERSION ${WINPR_VERSION} COMPATIBILITY SameMajorVersion
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/WinPR-toolsConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/WinPR-toolsConfigVersion.cmake DESTINATION ${WINPR_CMAKE_INSTALL_DIR}
)

install(EXPORT WinPR-toolsTargets DESTINATION ${WINPR_CMAKE_INSTALL_DIR})

=== channels/gfxredir/server/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2020 Microsoft
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

define_channel_server("gfxredir")

set(${MODULE_PREFIX}_SRCS gfxredir_main.c gfxredir_main.h)

set(${MODULE_PREFIX}_LIBS freerdp gfxredir-common)

add_channel_server_library(${MODULE_PREFIX} ${MODULE_NAME} ${CHANNEL_NAME} FALSE "DVCPluginEntry")

=== winpr/libwinpr/library/CMakeLists.txt ===
# WinPR: Windows Portable Runtime
# libwinpr-library cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

winpr_module_add(library.c)

if(BUILD_TESTING_INTERNAL OR BUILD_TESTING)
  add_subdirectory(test)
endif()

=== debian/changelog ===
freerdp3 (3.15.0+dfsg-1) unstable; urgency=medium

  [ Bernhard Miklautz ]
  * d/copyright:
     - fix lintian warning "old-fsf-address-in-copyright-file"
     - update files
  * d/control:
     - remove Multi-Arch: same field (for bin:pkg libwinpr3-dev)
       (Closes: #1101910)
     - drop unused build dependency to docbook-xsl

  [ Michael Tokarev ]
  * new upstream version (3.15.0)
  * install .desktop files and FreeRDP.svg icon

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 14 Apr 2025 18:35:14 +0300

=== debian/control ===
Source: freerdp3
Section: x11
Priority: optional
Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Bernhard Miklautz <bernhard.miklautz@shacknet.at>,
 Michael Tokarev <mjt@tls.msk.ru>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dpkg-dev (>= 1.22.5),
 libasound2-dev,
# ffmpeg is in universe in ubuntu (not enabled):
 libavcodec-dev, libavutil-dev, libswscale-dev,
# cairo is used on ubuntu only (alternative to swscale from ffmpeg):
 libcairo2-dev,
 libcjson-dev,
 libcups2-dev,
 libfuse3-dev,
 libgsm1-dev,
 libicu-dev,
 libjpeg-dev,
 libkrb5-dev,
 libopus-dev,
 libpam0g-dev,
 libpcsclite-dev,
 libpkcs11-helper1-dev,
 libpng-dev,
 libpulse-dev,
 libsdl2-dev <pkg.freerdp3.sdl2>,
 libsdl2-image-dev <pkg.freerdp3.sdl2>,
 libsdl2-ttf-dev <pkg.freerdp3.sdl2>,
 libsdl3-dev <!pkg.freerdp3.sdl2>,
 libsdl3-image-dev <!pkg.freerdp3.sdl2>,
 libsdl3-ttf-dev <!pkg.freerdp3.sdl2>,
 libssl-dev,
 libv4l-dev [linux-any],
 libswresample-dev,
 libsystemd-dev [linux-any],
 libudev-dev [linux-any],
 libusb-1.0-0-dev [linux-any],
 liburiparser-dev,
 libwayland-dev [linux-any],
 libwebp-dev,
 libx11-dev,
 libxcursor-dev,
 libxdamage-dev,
 libxext-dev,
 libxfixes-dev,
 libxinerama-dev,
 libxi-dev,
 libxkbcommon-dev,
 libxkbfile-dev,
 libxrandr-dev,
 libxrender-dev,
 libxtst-dev,
 libxv-dev,
 pkgconf,
 uuid-dev,
 xmlto,
 xsltproc,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.freerdp.com/
Vcs-Browser: https://salsa.debian.org/debian-remote-team/freerdp3
Vcs-Git: https://salsa.debian.org/debian-remote-team/freerdp3.git

Package: freerdp3-x11
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-client3-3 (= ${binary:Version}),
Provides:
 freerdp,
Description: RDP client for Windows Terminal Services (X11 client)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the X11 based client.

Package: libfreerdp3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libwinpr3-3 (= ${binary:Version}),
Multi-Arch: same
Suggests:
 freerdp3-x11,
Description: Free Remote Desktop Protocol library (core library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library with all core functionality.

Package: libfreerdp-client3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp3-3 (= ${binary:Version}),
Multi-Arch: same
Description: Free Remote Desktop Protocol library (client library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library for common client functionality.

Package: libfreerdp-server3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp3-3 (= ${binary:Version}),
Multi-Arch: same
Description: Free Remote Desktop Protocol library (server library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library with common server functionality.

Package: libwinpr3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Suggests:
 freerdp3-x11,
Description: Windows Portable Runtime library
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains the WinPR shared library.

Package: libwinpr-tools3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libwinpr3-3 (= ${binary:Version}),
Multi-Arch: same
Description: Windows Portable Runtime Tools library
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library for Windows Portable Runtime
 utilities and tools.

Package: libwinpr3-dev
Section: libdevel
Architecture: any
Depends:
 libssl-dev,
 libwinpr-tools3-3 (= ${binary:Version}),
 libwinpr3-3 (= ${binary:Version}),
 ${misc:Depends},
Description: Windows Portable Runtime library (development files)
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains the WinPR development files.

Package: freerdp3-dev
Section: devel
Architecture: any
Depends:
 libfreerdp-server-proxy3-3 (= ${binary:Version}),
 libfreerdp-client3-3 (= ${binary:Version}),
 libfreerdp-server3-3 (= ${binary:Version}),
 libfreerdp-shadow-subsystem3-3 (= ${binary:Version}),
 libfreerdp-shadow3-3 (= ${binary:Version}),
 libfreerdp3-3 (= ${binary:Version}),
 libwinpr3-dev (= ${binary:Version}),
 libcjson-dev,
 libfuse3-dev,
 winpr3-utils (= ${binary:Version}),
 ${misc:Depends},
Description: Free Remote Desktop Protocol library (development files)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the FreeRDP development files.

Package: winpr3-utils
Multi-Arch: foreign
Section: utils
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libwinpr-tools3-3 (= ${binary:Version}),
Description: Windows Portable Runtime library command line utilities
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains WinPR command line utils (winpr-hash, winpr-makecert).

Package: libfreerdp-shadow3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-server3-3 (= ${binary:Version}),
 libwinpr-tools3-3 (= ${binary:Version}),
Multi-Arch: same
Description: FreeRDP Remote Desktop Protocol shadow libraries
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shadow libraries.

Package: libfreerdp-shadow-subsystem3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-shadow3-3 (= ${binary:Version}),
Multi-Arch: same
Description: FreeRDP Remote Desktop Protocol shadow subsystem libraries
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shadow subsystem libraries.

Package: freerdp3-shadow-x11
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-shadow-subsystem3-3 (= ${binary:Version}),
Provides:
 freerdp,
Description: FreeRDP x11 shadowing server
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains a "shadowing" server that can be used to
 share an already started X11 DISPLAY.

Package: freerdp3-wayland
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-client3-3 (= ${binary:Version}),
Description: RDP client for Windows Terminal Services (wayland client)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the wayland based client.

Package: freerdp3-sdl
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-client3-3 (= ${binary:Version}),
Description: RDP client for Windows Terminal Services (SDL client)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the SDL based client.

Package: libfreerdp-server-proxy3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp3-3 (= ${binary:Version}),
 libfreerdp-client3-3 (= ${binary:Version}),
 libwinpr3-3 (= ${binary:Version}),
Multi-Arch: same
Description: Free Remote Desktop Protocol library (proxy library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library for proxying RDP connections.

Package: freerdp3-proxy-modules
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-server-proxy3-3 (= ${binary:Version}),
Description: FreeRDP Remote Desktop Protocol proxy module libraries
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the modules for the proxy.

Package: freerdp3-proxy
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-server-proxy3-3 (= ${binary:Version}),
 libfreerdp3-3 (= ${binary:Version}),
 libwinpr3-3 (= ${binary:Version}),
Suggests:
 freerdp3-proxy-modules,
Description: FreeRDP proxy server
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the proxy server that can be used
 as man in the middle proxy for RDP connections.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
    export DH_VERBOSE = 1
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4
DPKG_EXPORT_BUILDFLAGS = 1

CFLAGS   += $(CPPFLAGS) -DNDEBUG
CXXFLAGS += $(CPPFLAGS) -DNDEBUG

empty :=

DEB_CMAKE_EXTRA_FLAGS = \
    -DCMAKE_INSTALL_INCLUDEDIR=include/$(DEB_HOST_MULTIARCH) \
    -DCMAKE_SKIP_RPATH=FALSE \
    -DCMAKE_SKIP_INSTALL_RPATH=TRUE \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DWITH_DEBUG_ALL=OFF \
    -DBUILD_TESTING=ON \
    -DWITH_CHANNELS=ON \
    -DWITH_SERVER=ON \
    -DWITH_PROXY=ON \
    -DWITH_PROXY_MODULES=ON \
    -DWITH_CLIENT_INTERFACE=OFF \
    -DWITH_CLIENT_SDL=ON \
    -DWITH_CLIENT_SDL_VERSIONED=OFF \
    -DWITH_CLIENT_SDL2=$(if $(filter pkg.freerdp3.sdl2,${DEB_BUILD_PROFILES}),ON,OFF) \
    -DWITH_CLIENT_SDL3=$(if $(filter pkg.freerdp3.sdl2,${DEB_BUILD_PROFILES}),OFF,ON) \
    -DWITH_SDL_IMAGE_DIALOGS=ON \
    -DWITH_WEBVIEW=OFF \
    -DWITH_PULSE=ON \
    -DWITH_ICU=ON \
    -DWITH_CUPS=ON \
    -DWITH_PCSC=ON \
    -DWITH_JPEG=ON \
    -DWITH_KERBEROS=ON \
    -DCHANNEL_RDPEAR=ON -DCHANNEL_RDPEAR_CLIENT=ON \
    -DWITH_CLANG_FORMAT=OFF \
    -DWITH_OPUS=ON \
    -DWITH_SAMPLE=OFF \
    -DWITH_OPENSC_PKCS11_LINKED=OFF \
    -DWITH_VAAPI=OFF \
    -DWITH_WINPR_UTILS_IMAGE_JPEG=ON \
    -DWITH_WINPR_UTILS_IMAGE_PNG=ON \
    -DWITH_WINPR_UTILS_IMAGE_WEBP=ON \
    -DWITH_SMARTCARD_EMULATE=ON \
    -DRDTK_FORCE_STATIC_BUILD=ON \
    -DUWAC_FORCE_STATIC_BUILD=ON \
    -DWITH_BINARY_VERSIONING=ON \
    -DWITH_VERBOSE_WINPR_ASSERT=OFF \
    -DWITH_INSTALL_CLIENT_DESKTOP_FILES=ON \
    $(empty)

ifneq (,$(filter armel,$(DEB_HOST_ARCH)))
    DEB_CMAKE_EXTRA_FLAGS += \
        -DWITH_NEON=OFF \
        $(empty)
endif

ifneq (,$(filter armel armhf,$(DEB_HOST_ARCH)))
# https://github.com/FreeRDP/FreeRDP/issues/10353
# gcc/glibc does not provide _URC_NORMAL_STOP etc definitions in
# <unwind.h> on armel armhf
# it's proabbly be better to perform a build-time check instead
# -DWITH_UNWIND=OFF does not work in version 3.6
    DEB_CMAKE_EXTRA_FLAGS += \
        -DWINPR_HAVE_UNWIND_H=OFF \
        $(empty)
endif

ifneq (,$(filter linux,$(DEB_HOST_ARCH_OS)))
    DEB_CMAKE_EXTRA_FLAGS += \
        -DCHANNEL_URBDRC=ON \
        -DCHANNEL_URBDRC_CLIENT=ON \
        -DWITH_WAYLAND=ON \
        -DWITH_VAAPI_H264_ENCODING=ON \
        -DCHANNEL_RDPECAM=ON \
        -DCHANNEL_RDPECAM_CLIENT=ON \
        $(empty)
else
    DEB_CMAKE_EXTRA_FLAGS += \
        -DCHANNEL_URBDRC=OFF \
        -DCHANNEL_URBDRC_CLIENT=OFF \
        $(empty)

    DEB_CMAKE_EXTRA_FLAGS += \
        -DWITH_ALSA=OFF \
        -DWITH_LIBSYSTEMD=OFF \
        -DWITH_WAYLAND=OFF \
        $(empty)
endif

# Ubuntu can't have ffmpeg in main
# Ubuntu doesn't yet have cjson or pkcs11-helper
# or uriparser in main
ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes),yes)
    DEB_CMAKE_EXTRA_FLAGS += \
        -DWITH_JSON_DISABLED=ON \
        -DWITH_FFMPEG=OFF \
        -DWITH_GSM=OFF \
        -DWITH_CAIRO=ON \
        -DWITH_PKCS11=OFF \
        -DWITH_SWSCALE=OFF \
        -DWITH_URIPARSER=OFF \
        -DCHANNEL_RDPECAM_CLIENT=OFF \
        $(empty)
else
    DEB_CMAKE_EXTRA_FLAGS += \
        -DWITH_GSM=ON \
        -DWITH_SWSCALE=ON \
        -DWITH_DSP_FFMPEG=ON \
        -DSWScale_INCLUDE_DIRS=/usr/include/$(DEB_HOST_MULTIARCH) \
        -DWITH_CAIRO=OFF \
        $(empty)
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)
